// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <memory>
#include <string>
#include <vector>

#include <aoc/Solver.hpp>

class TestContext
{
public:
    void run(const std::unique_ptr<Solver>&& solver, const long long int expected1, const long long int expected2,
        const std::vector<std::string>& inputPaths);
    void runPart2(const std::unique_ptr<Solver>&& solver, const long long int expected,
        const std::vector<std::string>& inputPaths);
    std::vector<std::string> getInputPaths() const;
    std::vector<std::string> getExampleInputPaths() const;
};
